<?php
  // code included in displayimage.pgp ONLY when executed outside of Coppermine...
  // set us up to be able to function without the pre-setup that Coppermine does for us.
  $debug_trace[] = 'MaskUrl display image invoked outside Coppermine';

  define('IN_COPPERMINE', true);                                                // need to be able to include code that checks this setting
  // sanitize input
  // Unable to include Inspekt from Coppermine invoked this way.. (the cascading includes fail to resolve since I am 2 levels down the directory structure...)
  // Only input are 2 GET variables - both would be getRaw (encrypted/encoded string) thru Inspekt.
  // Contents are validated as legitimate and reasonable before use.

  // Set a flag if register globals is on
  if (ini_get('register_globals') == '1' || strtolower(ini_get('register_globals')) == 'on') {
    $register_globals_flag = true;
  } else {
    $register_globals_flag = false;
  }
  // Remove any GLOBAL variables introduced by register_globals, if enabled
  $keysToSkip = array('keysToSkip', 'register_globals_flag', 'superCage', 'cpg_time_start', 'keyname');
  if ($register_globals_flag && is_array($_GLOBALS)) {
    foreach ($$_GLOBALS as $keyname => $value) {
      if (!in_array($keyname, $keysToSkip) && isset($$keyname)) {
          unset($$keyname);
      }
    }
  }
  // capture GET data required (validated later...)
  $photopath = $_GET['photopath'];
  $photokey = $_GET['photokey'];

  // establish communication with Coppermine and extract plugin related data
  // From cpg_config:
  // - plugin_maskurl_*  - all plugin specific variables
  // - fullpath                 - coppermine config path to albums directory relative to coppermine root
  // - lang                     - coppermine config language setting
  // - picture_width            - coppermine config width of normal/intermediate photo
  // - thumb_pfx                - coppermine config prefix to thumb photos
  // - thumb_width              - coppermine config width of thumb photos
  // function from Coppermine include/init.inc.php included here - as init.inc.php can only be invoked within coppermine... and does a lot we don't need.
  if (!function_exists(cpgGetMicroTime)) {
    function cpgGetMicroTime() {
      list($usec, $sec) = explode(' ', microtime());
      return ((float)$usec + (float)$sec);
    }
  }
  ob_start();
  require_once ("../../include/config.inc.php");                                // coppermine database config
  ob_clean();
  require_once ("../../include/functions.inc.php");                             //   and functions
  $CONFIG['TABLE_CONFIG']        = $CONFIG['TABLE_PREFIX'].'config';            // set additional constants we need
  $CONFIG['TABLE_FILETYPES']     = $CONFIG['TABLE_PREFIX'].'filetypes';
  $db = cpg_db_connect();                                                       // connect to db
  $sql = "SELECT * FROM {$CONFIG['TABLE_CONFIG']} WHERE name LIKE 'plugin_maskurl%'
                                                             OR name = 'cookie_name'
                                                             OR name = 'fullpath'
                                                             OR name = 'lang'
                                                             OR name = 'picture_width'
                                                             OR name = 'thumb_pfx'
                                                             OR name = 'thumb_width';";
  $result = cpg_db_query($sql, $db);                                            // obtain config values
  while ($configdata = cpg_db_fetch_row($result)) {
      $CONFIG["{$configdata['name']}"] = $configdata['value'];                  // populate array
  }
  // set constants - execution is in plugins directory
  $includeprefix = '';                                                          // prefix for code includes
  $fileprefix = '../../';                                                       // prefix for access to albums directory
  // see if we need cookie information for dynamic encryption
  if ($CONFIG["plugin_maskurl_mask_url"] == 3) {
    $debug_trace[] = 'Dynamic Encryption - loading IV';
//echo 'Cookies: <pre>'.print_r($_COOKIE, TRUE).'</pre><br />';
    if (key_exists($CONFIG['cookie_name'] . "_maskurl", $_COOKIE)) {
      $CONFIG["plugin_maskurl_encrypt_iv"] = $_COOKIE[$CONFIG['cookie_name'] . "_maskurl"];
      $debug_trace[] = "IV: {$CONFIG["plugin_maskurl_encrypt_iv"]}";
    }
  }
?>