<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

if (!defined('IN_COPPERMINE')) {
  // allow direct display - add necessary html
  echo <<< EOT
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
    <head>
        <title>Mask URLs Readme</title>
        <link rel="stylesheet" href="../../css/coppermine.css" type="text/css" />
        <link rel="stylesheet" href="../../themes/curve/style.css" type="text/css" />
        <script src="docs/js/jquery.js" type="text/javascript"></script>
        <script src="docs/js/help.js" type="text/javascript"></script>
    </head>
    <body>
        <div id="cpg_main_block">
          <p>&nbsp;<p>
          <table align="center" width="100%" cellspacing="1" cellpadding="0" class="maintable cpg_zebra">
            <tr>
                <td class="" colspan="3">
                    <div class="cpg_starttable_outer">
                        <div class="cpg_starttable_inner">
                            View Documentation
                        </div>
                    </div>
                </td>
            </tr>
EOT;
}

echo <<< EOT
  <tr>
    <td colspan=3>
      <h2>
      Mask URLs:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

This plugin adds the  ability to mask or hide the actual file location of your pictures...
Normally the delivered html contains &lt;img&gt; tags that can be read to find your photo locations and directory structure.
As the photos are delivered via &lt;img&gt; tags, http access must be provided to the album folder (and subfolders).
This allows curious (or malicious) users an easy opportunity to find your pictures and download them.
But what if the delivered html looked like this:<br>
  &nbsp;&nbsp;&lt;img src="index.php?file=maskurl/displayimage&photokey=8dOgllfG1PqJQwj0%2BNuSOMuDNKC%2B14ABd6Rfn7nhZNXVaB9bn0V1IOUTZ%2FGw" ...&gt;<br>
Since the path to the albums directory is configurable (doesn't have to be 'albums/') and of course you can have any subfolder structure you
want... the task of locating your pictures files is made harder... to near impossible (based on your choices configuring the plugin).
<p>
Options to 'mask' or 'encrypt' the path to photos are offered.
These options appear to have similar results - but the algorithm used has quite different results. 
The masking can be decoded by anyone that can read/understand the PHP being used (access to this plugin's source).
The encryption requires encryption keys and initialization vectors that would require access to specific fields in your Coppermine database
in addition to the PHP code to be able to reverse. The encryption option will use more CPU resources - but provides better protection.<br>
The choice is of course yours...
<p>
An additional benefit if masking/encrypting is that http access to the albums directory is no longer required... All CPG functions generating the picture
URL drive this plugin, and all will be changed.  As a result, a .htaccess file can be placed in the albums directory denying all access - providing additonal
protecting for your photos. A sample .htaccess file is included in the plugin directory - named .htaccess.txt - this needs to be copied to the albums directory
and named .htaccess if you wish to use it.<br>
NOTE: If you disable this plugin and have the .htaccess file in place, you will be unable to view photos in your gallery!!
<p>
All filetypes permitted by CPG are supported (based on the contents of cpg15x_filetypes table). Proper additions to that table will be
automatically recognized by the plugin and supported. The 'mime' type must be correctly specified in that table!

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Installation:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Unzip the distribution files and upload the contents (including folder maskurl) to your plugins directory.
In admin mode, select Plugin Manager, and click install next to this plugin.
<p>

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Uninstall:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Select Plugin Manager, and click uninstall next to this plugin.<br>
The normal plugin manager confirmation will be displayed - Click 'OK' to uninstall.

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Configuration:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Select configure on this plugin from Plugin Manager.<br>
Select appropriate check boxes, based on preferences.
EOT;

if (!defined('IN_COPPERMINE')) {
  // for direct display - add image of config screen
  echo <<< EOT
  <p><img src='readme_config.png' alt='config menu'>
EOT;
}

echo <<< EOT
<p>
Setting Descriptions:
<ul>
  <li>Mask Picture URL<br>
    Select the desired option based on level of security desired.
    <ul>
      <li>Clear Text - normal CPG processing - URLs contain the photo location in clear text</li>
      <li>Mask URL - Mathematical functions used to obscure the URL - more protection than clear text, but can be reversed by someone willing to take the time and read/understand the code.</li>
      <li>Encrypt URL - Uses mcrypt_cbc functions to encrypt the URL - offers more protection with higher resource usage (remember a thumbnail page will call this many times!)
        A low traffic gallery should see no issue. Verify your resource usage before/after on high traffic volume galleries.</li>
      <li>Encrypt URL with Dynamic IV - Same encryption as above, but on each page load generates a new Initialization Vecto that gets sent as a cookie to the client.
        The cookie is retrieved by the plugins displayimage.php to combine with the database stored encryption key to decrypt and locate the image.<br />
        Note this can cause issues with other display methods - including for plugins like EnlargeIt. See "Use 'external' URL format" below.
        A low traffic gallery should see no issue. Verify your resource usage before/after on high traffic volume galleries.</li>
    </ul></li>
  <li>Encryption Algorithm<br>
    Encryption algorithms installed on your webserver environment are listed to choose from. The default is  'rjindael-128' more commonly known as AES-128.
    Changing the encryption algorithm will force a refresh of the encryption keys to insure key and iv sizes are correct for the new selection.<br />
    I have not tested all combinations of algorithms and modes - not all combinations may be valid or recommended. If unsure, leave the default values.</li>
  <li>Encryption Mode<br>
    Encryption modes installed on your webserver environment are listed to choose from. The default is  'cfb'.
    Changing the encryption algorithm will force a refresh of the encryption keys to insure key and iv sizes are correct for the new selection.</li>
  <li>Refresh Encryption Keys<br>
    Encryption keys are generated when plugin is installed and stored in the config table.
    Checking this box will refresh the keys - generating a new set.
    As the encrypted URL strings are not saved - they are used within seconds (or less) of being generated -
    these keys can be regenerated any time you like with no impact... </li>
  <li>Is Webserver Windows OS<br>
    If a Windows OS, and PHP is older than 5.3, different parameters/functions are needed to initialize the encryption keys.
    Checking this box will allow proper initialization. The correct value should be pre-selected for you.<br>
    If PHP is greater or equal to 5.3 - it is_a no longer necessary (support was added to Windows to match other environments. </li>
  <li>Use 'external' URL format<br>
    By default the plugin with use a urldecode format that drives Coppermine Initialization. If using 'Encrypt URL with Dynamic IV', this can cause a problem
    for some plugins - like EnlargeIt - as driving Coppermine will recreate the Initialization Vector (IV) saved in clients cookie - and will no longer be
    able to decrypt the URLs previously generated and passed in_array by EnlargeIt.<br>
    To address this - you can select an 'external' URL format - which will perform its own initialization of only the minimum needed for the decryption.
    This functions properly with EnlargeIT - but is a more 'non-standard' approach.
    </li>
</ul>
<p>&nbsp;<br />
Once submitted, validated, your settings will be saved, and the configuration screen redisplayed with results.<br>
A sample URL will be displayed in normal format - and using your current options to show the difference.
<p>
As part of validation, the plugin will verify encryption functions are available, and the requested encryption algorithm and mode is
installed. The plugin will install in any event, but selection of 'Encrypt URL' will not be available. Additional messages will
indicate the error - and provide the requested algorithm and mode, and those available in your installation.<br>
Select 'Refresh Encryption Keys' to re-drive initialization.
    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Execution:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Plugin will be invoked (assuming Plugin API is active) anytime a picture url is generated by CPG.<br>
You can see the effect of this plugin at <a href="http://gallery.gmcdesign.com" target="_new">http://gallery.gmcdesign.com</a>
running with a variation of this plugin set to encrypt urls and the .htaccess protection in place.
    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
    </td>
  </tr>
  <tr>
    <td>

Your comments are welcome.<br>
I hope you find this useful.<br>
Greg (gmc on the CPG forum)

    </td>
  </tr>
EOT;

if (!defined('IN_COPPERMINE')) {
  // allow direct display - add necessary html
  echo <<< EOT
          </table>
       </div>
    </body>
  </html>
EOT;
}
?>